import javax.swing.UIManager;
import java.awt.*;

/**
 *
 * ColorCalibration  v1.0
 *
 * Tool to calibrate colortables used by Aibo robot dogs by Sony corporation 
 *
 * By Carl Axelsson and Jens Trner 2003
 * (c) 2003 Lund University
 *
 * Based in part on software developed by Zbigniew Wasik and Alessandro Saffiotti, 
 * used with permission. (c) 1999-2002 rebro University
 *
 */
public class ColorCalibration {

    // Constructor, only starts up an instance of the core class, eg the top window
    public ColorCalibration() {
	CalibrationCore frame = new CalibrationCore(); // Start the core window
	
	frame.validate();
	
	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = frame.getSize();

	// make sure the window is not bigger than the screen
	if (frameSize.height > screenSize.height) { 
	    frameSize.height = screenSize.height;
	}
	if (frameSize.width > screenSize.width) {
	    frameSize.width = screenSize.width;
	}

	frame.setLocation(0,0); // place window in the top left corner
	frame.setVisible(true);
    }

    // Main method
    public static void main(String[] args) {
	try {
	    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
	}
	catch(Exception e) {
	    System.out.println("Start failed. Good bye.");
	    System.exit(0);
	}
	new ColorCalibration();
    }
}
