import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * Handles the preferences window
 */
public class PreferencesWindowFrame extends JFrame {
    private JPanel contentPane;
        
    // color options pane and labels
    private JPanel colorOptions = new JPanel();
    private JLabel use = new JLabel("Use"); 
    private JLabel name = new JLabel("Name"); 
    private JLabel col = new JLabel("Color"); 
    
    // the color options
    private boolean checked = true;
    private JCheckBox color0CheckBox = new JCheckBox("", CalibrationCore.colorsChecked[0]);
    private JCheckBox color1CheckBox = new JCheckBox("", CalibrationCore.colorsChecked[1]);
    private JCheckBox color2CheckBox = new JCheckBox("", CalibrationCore.colorsChecked[2]);
    private JCheckBox color3CheckBox = new JCheckBox("", CalibrationCore.colorsChecked[3]);
    private JCheckBox color4CheckBox = new JCheckBox("", CalibrationCore.colorsChecked[4]);
    private JCheckBox color5CheckBox = new JCheckBox("", CalibrationCore.colorsChecked[5]);
    private JCheckBox color6CheckBox = new JCheckBox("", CalibrationCore.colorsChecked[6]);
    private JCheckBox color7CheckBox = new JCheckBox("", CalibrationCore.colorsChecked[7]);
    private JCheckBox color8CheckBox = new JCheckBox("", CalibrationCore.colorsChecked[8]);
    private JCheckBox color9CheckBox = new JCheckBox("", CalibrationCore.colorsChecked[9]);
    private JCheckBox color10CheckBox = new JCheckBox("", CalibrationCore.colorsChecked[10]);
    private JTextField color0Text = new JTextField(CalibrationCore.colorNames[0]);
    private JTextField color1Text = new JTextField(CalibrationCore.colorNames[1]);
    private JTextField color2Text = new JTextField(CalibrationCore.colorNames[2]);
    private JTextField color3Text = new JTextField(CalibrationCore.colorNames[3]);
    private JTextField color4Text = new JTextField(CalibrationCore.colorNames[4]);
    private JTextField color5Text = new JTextField(CalibrationCore.colorNames[5]);
    private JTextField color6Text = new JTextField(CalibrationCore.colorNames[6]);
    private JTextField color7Text = new JTextField(CalibrationCore.colorNames[7]);
    private JTextField color8Text = new JTextField(CalibrationCore.colorNames[8]);
    private JTextField color9Text = new JTextField(CalibrationCore.colorNames[9]);
    private JTextField color10Text = new JTextField(CalibrationCore.colorNames[10]);
    private JButton color0Button = new JButton("Select");
    private JButton color1Button = new JButton("Select");
    private JButton color2Button = new JButton("Select");
    private JButton color3Button = new JButton("Select");
    private JButton color4Button = new JButton("Select");
    private JButton color5Button = new JButton("Select");
    private JButton color6Button = new JButton("Select");
    private JButton color7Button = new JButton("Select");
    private JButton color8Button = new JButton("Select");
    private JButton color9Button = new JButton("Select");
    private JButton color10Button = new JButton("Select");
    private JButton allNone = new JButton("All / None");
    private JButton nameDefault = new JButton("Default");
    private JButton colorDefault = new JButton("Default");

    // the buttons
    private JButton apply = new JButton("Apply");
    private JButton ok = new JButton("Ok");
    private JButton cancel = new JButton("Cancel");

    // dog code in c++ (or other language) library chooser
    private JTextField dogLibName = new JTextField(CalibrationCore.nativeCode);
    private JLabel dogLibLabel = new JLabel("Name of PAM library:");
    private JCheckBox useNative = new JCheckBox("Use native", CalibrationCore.useNativeSegmentation);

    public PreferencesWindowFrame() {
	enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	try {
	    prefInit();
	}
	catch(Exception e) {
	    JOptionPane.showMessageDialog(null, "An error occured and ColorCalibration will now close\nSorry");
	    System.exit(0);
	}
    }

    private void prefInit() {
	contentPane = (JPanel) this.getContentPane();
	contentPane.setLayout(null);  // absolute positioning
	this.setSize(390, 345);
	this.setTitle("Preferences");

	colorOptions.setBounds(new Rectangle(0, 0, 380, 255));
	colorOptions.setLayout(new GridLayout(13,3));
	colorOptions.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Color options"));

	// color options
	colorOptions.add(use, null);
	colorOptions.add(name, null);
	colorOptions.add(col, null);

	colorOptions.add(color0CheckBox, null);
	colorOptions.add(color0Text, null);
	colorOptions.add(color0Button, null);
  	color0Button.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {

		    Color c = JColorChooser.showDialog(null, "Choose Color", CalibrationCore.colorValue[0]);

		    if (c != null)
			CalibrationCore.colorValue[0] = c;
		}
	    });
	colorOptions.add(color1CheckBox, null);
	colorOptions.add(color1Text, null);
	colorOptions.add(color1Button, null);
  	color1Button.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {

		    Color c = JColorChooser.showDialog(null, "Choose Color", CalibrationCore.colorValue[1]);

		    if (c != null)
			CalibrationCore.colorValue[1] = c;
		}
	    });
	colorOptions.add(color2CheckBox, null);
	colorOptions.add(color2Text, null);
	colorOptions.add(color2Button, null);
  	color2Button.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {

		    Color c = JColorChooser.showDialog(null, "Choose Color", CalibrationCore.colorValue[2]);

		    if (c != null)
			CalibrationCore.colorValue[2] = c;
		}
	    });
	colorOptions.add(color3CheckBox, null);
	colorOptions.add(color3Text, null);
	colorOptions.add(color3Button, null);
  	color3Button.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {

		    Color c = JColorChooser.showDialog(null, "Choose Color", CalibrationCore.colorValue[3]);

		    if (c != null)
			CalibrationCore.colorValue[3] = c;
		}
	    });
	colorOptions.add(color4CheckBox, null);
	colorOptions.add(color4Text, null);
	colorOptions.add(color4Button, null);
  	color4Button.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {

		    Color c = JColorChooser.showDialog(null, "Choose Color", CalibrationCore.colorValue[4]);

		    if (c != null)
			CalibrationCore.colorValue[4] = c;
		}
	    });
	colorOptions.add(color5CheckBox, null);
	colorOptions.add(color5Text, null);
	colorOptions.add(color5Button, null);
  	color5Button.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {

		    Color c = JColorChooser.showDialog(null, "Choose Color", CalibrationCore.colorValue[5]);

		    if (c != null)
			CalibrationCore.colorValue[5] = c;
		}
	    });
	colorOptions.add(color6CheckBox, null);
	colorOptions.add(color6Text, null);
	colorOptions.add(color6Button, null);
  	color6Button.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {

		    Color c = JColorChooser.showDialog(null, "Choose Color", CalibrationCore.colorValue[6]);

		    if (c != null)
			CalibrationCore.colorValue[6] = c;
		}
	    });
	colorOptions.add(color7CheckBox, null);
	colorOptions.add(color7Text, null);
	colorOptions.add(color7Button, null);
  	color7Button.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {

		    Color c = JColorChooser.showDialog(null, "Choose Color", CalibrationCore.colorValue[7]);

		    if (c != null)
			CalibrationCore.colorValue[7] = c;
		}
	    });
	colorOptions.add(color8CheckBox, null);
	colorOptions.add(color8Text, null);
	colorOptions.add(color8Button, null);
  	color8Button.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {

		    Color c = JColorChooser.showDialog(null, "Choose Color", CalibrationCore.colorValue[8]);

		    if (c != null)
			CalibrationCore.colorValue[8] = c;
		}
	    });
	colorOptions.add(color9CheckBox, null);
	colorOptions.add(color9Text, null);
	colorOptions.add(color9Button, null);
  	color9Button.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {

		    Color c = JColorChooser.showDialog(null, "Choose Color", CalibrationCore.colorValue[9]);

		    if (c != null)
			CalibrationCore.colorValue[9] = c;
		}
	    });
	colorOptions.add(color10CheckBox, null);
	colorOptions.add(color10Text, null);
	colorOptions.add(color10Button, null);
  	color10Button.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {

		    Color c = JColorChooser.showDialog(null, "Choose Color", CalibrationCore.colorValue[10]);

		    if (c != null)
			CalibrationCore.colorValue[01] = c;
		}
	    });
	colorOptions.add(allNone, null);
	allNone.setToolTipText("Check or uncheck all colors");
  	allNone.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    checked = !checked;
		    color0CheckBox.setSelected(checked);
		    color1CheckBox.setSelected(checked);
		    color2CheckBox.setSelected(checked);
		    color3CheckBox.setSelected(checked);
		    color4CheckBox.setSelected(checked);
		    color5CheckBox.setSelected(checked);
		    color6CheckBox.setSelected(checked);
		    color7CheckBox.setSelected(checked);
		    color8CheckBox.setSelected(checked);
// 		    color9CheckBox.setSelected(checked);
// 		    color10CheckBox.setSelected(checked);
		}
	    });
	colorOptions.add(nameDefault, null); // restor color names to default
	nameDefault.setToolTipText("Restore color names to default");
  	nameDefault.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    color0Text.setText("Orange");
		    color1Text.setText("Yellow");
		    color2Text.setText("SBlue");
		    color3Text.setText("Pink");
		    color4Text.setText("Green");
		    color5Text.setText("Red");
		    color6Text.setText("DBlue");
		    color7Text.setText("White");
		    color8Text.setText("Carpet");
		    color9Text.setText("Black");
		    color10Text.setText("Silver");
		}
	    });
	colorOptions.add(colorDefault, null); // restore color values to default
	colorDefault.setToolTipText("Restore colors to default colors");
  	colorDefault.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    CalibrationCore.colorValue[0] = new Color(255,105,00);
		    CalibrationCore.colorValue[1] = Color.yellow;
		    CalibrationCore.colorValue[2] = Color.cyan;
		    CalibrationCore.colorValue[3] = Color.pink;
		    CalibrationCore.colorValue[4] = Color.green;
		    CalibrationCore.colorValue[5] = Color.red;
		    CalibrationCore.colorValue[6] = Color.blue;
		    CalibrationCore.colorValue[7] = Color.white;
		    CalibrationCore.colorValue[8] = new Color(0,160,0);
		    CalibrationCore.colorValue[9] = Color.black;
		    CalibrationCore.colorValue[10] = Color.lightGray;
		}
	    });
	contentPane.add(colorOptions, null);

	//apply button
	apply.setBounds(new Rectangle(270, 285, 110, 25));
  	apply.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    apply();		    
		}
	    });

	//ok button
	ok.setBounds(new Rectangle(40, 285, 110, 25));
  	ok.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    apply();		    
		    hide();
		}
	    });
	
	//cancel button
	cancel.setBounds(new Rectangle(155, 285, 110, 25));
  	cancel.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    hide();
		}
	    });


	contentPane.add(apply, null);
	contentPane.add(ok, null);
	contentPane.add(cancel, null);

	//dog lib
	dogLibLabel.setBounds(new Rectangle(2, 257, 140, 20));
	dogLibName.setBounds(new Rectangle(142, 257, 122, 20));
	dogLibName.setToolTipText("Name of the library containing the native segmentation code");
	useNative.setBounds(new Rectangle(265, 257, 125, 20));
	useNative.setToolTipText("Indicates if native segmentation is used or not");

	contentPane.add(dogLibLabel, null);
	contentPane.add(dogLibName, null);
	contentPane.add(useNative, null);

    } 

    private void apply() {
	CalibrationCore.colorsChecked[0] = color0CheckBox.isSelected();
	CalibrationCore.colorsChecked[1] = color1CheckBox.isSelected();
	CalibrationCore.colorsChecked[2] = color2CheckBox.isSelected();
	CalibrationCore.colorsChecked[3] = color3CheckBox.isSelected();
	CalibrationCore.colorsChecked[4] = color4CheckBox.isSelected();
	CalibrationCore.colorsChecked[5] = color5CheckBox.isSelected();
	CalibrationCore.colorsChecked[6] = color6CheckBox.isSelected();
	CalibrationCore.colorsChecked[7] = color7CheckBox.isSelected();
	CalibrationCore.colorsChecked[8] = color8CheckBox.isSelected();
	CalibrationCore.colorsChecked[9] = color9CheckBox.isSelected();
	CalibrationCore.colorsChecked[10] = color10CheckBox.isSelected();
	
	CalibrationCore.colorNames[0] = color0Text.getText();
	CalibrationCore.colorNames[1] = color1Text.getText();
	CalibrationCore.colorNames[2] = color2Text.getText();
	CalibrationCore.colorNames[3] = color3Text.getText();
	CalibrationCore.colorNames[4] = color4Text.getText();
	CalibrationCore.colorNames[5] = color5Text.getText();
	CalibrationCore.colorNames[6] = color6Text.getText();
	CalibrationCore.colorNames[7] = color7Text.getText();
	CalibrationCore.colorNames[8] = color8Text.getText();
	CalibrationCore.colorNames[9] = color9Text.getText();
	CalibrationCore.colorNames[10] = color10Text.getText();
	
	CalibrationCore.nativeCode = dogLibName.getText();
	CalibrationCore.useNativeSegmentation = useNative.isSelected();
	
	CalibrationCore.toolbox.updateColors();
    }

}
